/*
 * lilJudd
 * Copyright (C) 2024 moonleay
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package net.moonleay.lilJudd.jobs

import dev.inmo.krontab.KronScheduler
import dev.kord.common.entity.PresenceStatus
import kotlinx.coroutines.Job
import net.moonleay.lilJudd.Bot
import net.moonleay.lilJudd.data.api.splatoon3ink.Splatoon3ApiDataGrabber
import net.moonleay.lilJudd.jobs.component.CronjobType
import net.moonleay.lilJudd.jobs.component.ICronjob

object StatusUpdater : ICronjob {
    override val jobName: String
        get() = "StatusUpdater"
    override val jobIncoming: String
        get() = "/10 * * * * * 0o *" //Every 5 seconds
    override val jobType: CronjobType
        get() = CronjobType.INFINITE
    override val continueJob: Boolean
        get() = true
    override lateinit var cronjobJob: Job
    override lateinit var scheduler: KronScheduler

    private var statusList = listOf<String>()
    private var index = 0

    // I h8 this cronjob. I'll recode this someday.
    override suspend fun jobFunction() {
        if (index >= statusList.size) {
            index = 0
            refreshStatusList(System.currentTimeMillis())
        }
        Bot.bot.kordRef.editPresence {
            this.status = PresenceStatus.DoNotDisturb
            this.competing(statusList[index])
        }
        ++index
    }

    private fun refreshStatusList(timestamp: Long) {
        statusList = listOf(
            Splatoon3ApiDataGrabber.getRotationTime(timestamp),
            Splatoon3ApiDataGrabber.getRegularMapsFormatted(timestamp),
            Splatoon3ApiDataGrabber.getOpenMapFormatted(timestamp),
            Splatoon3ApiDataGrabber.getSeriesMapsFormatted(timestamp),
            Splatoon3ApiDataGrabber.getXMapFormatted(timestamp)
        )
    }
}
